<template>
  <div>
    <el-card class="el-card" style="margin-top: -15px">
      <div>
        <el-form :model="listQuery" size="mini"
                 v-if="showSearch"
                 label-width="100px">
          <el-row>
            <el-col :span="8">
              <el-form-item label="外部系统:">
                <el-select v-model="listQuery.thirdSysFk" style="width: 90%" placeholder="请选择第三方系统"
                           clearable="true" @change="thirdSysChange">
                  <el-option
                    v-for="item in thirdSys"
                    :key="item.thirdId"
                    :label="item.thirdName"
                    :value="item.thirdId">
                    <span style="float: left;font-size: 13px">{{ item.thirdName }}</span>
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>

            <el-col :span="8">
              <el-form-item class="query-form-item" label="单据号:">
                <el-input
                  style="width: 90%"
                  v-model="listQuery.billNo"
                  placeholder="单据号"
                  clearable
                ></el-input>
              </el-form-item>
            </el-col>


            <el-col :span="8">
              <el-form-item class="query-form-item" label="单据类型:">
                <el-select v-model="listQuery.billAction" placeholder="请选择第三方系统单据类型" filterable clearable="true"
                           style="width: 90%">
                  <el-option
                    v-for="item in originTypes"
                    :key="item.name"
                    :label="item.name"
                    :value="item.action">
                    <span style="float: left;font-size: 13px">{{ item.name }}</span>
                    <span style="float: right; color: #8492a6; font-size: 13px;margin-left: 10px">{{
                        item.thirdSysName
                      }}</span>
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="往来单位:">
                <el-input v-model="listQuery.corpName" style="width: 90%" placeholder="请输入往来单位" clearable></el-input>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item class="query-form-item" label="单据日期:">
                <el-date-picker
                  :picker-options="pickerOptions"
                  v-model="actDateRange"
                  type="daterange"
                  format="yyyy 年 MM 月 dd 日"
                  value-format="yyyy-MM-dd"
                  range-separator="至"
                  start-placeholder="开始日期"
                  end-placeholder="结束日期" style="width: 90%"

                >
                </el-date-picker>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div class="top-right-btn">
          <el-button-group>
            <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>

            <el-button
              type="primary"
              icon="el-icon-refresh"
              @click="onReset"
            >重置
            </el-button>
            <el-button type="primary" icon="el-icon-search" @click="submitFind">查询</el-button>
            <el-button type="primary" icon="el-icon-check" @click="combine" :loading="determineLoading"
            >确定
            </el-button
            >
          </el-button-group>
        </div>
        <el-divider style="margin: 15px"></el-divider>
        <el-table
          :data="dataList"
          style="width: 100%"
          highlight-current-row="true"
          v-loading="loading"
          border
          :row-class-name="tableRowClassName"
          @current-change="handleChange"
        >
          <el-table-column label="序号" type="index"></el-table-column>
          <el-table-column label="单据号" prop="billNo"></el-table-column>
          <el-table-column label="往来单位" prop="corpName" width="300"
                           show-overflow-tooltip="true"></el-table-column>
          <el-table-column label="单据类型" prop="billType"></el-table-column>
          <el-table-column label="单据状态" prop="billFlag" width="80"></el-table-column>
          <el-table-column label="单据日期" prop="billdate"></el-table-column>
        </el-table>
        <el-pagination
          :page-size="listQuery.limit"
          @current-change="handleErpPageChange"
          layout="prev, pager, next"
          :total="pageTotal"
          :current-page="listQuery.page"
        ></el-pagination>
      </div>
    </el-card>

    <el-card class="el-card">
      <el-table v-loading="loading" :data="detailList" style="width: 100%" border>
        <el-table-column label="序号" type="index" width="120"></el-table-column>
        <el-table-column label="药品编码" prop="productId"></el-table-column>
        <el-table-column label="药品名称" prop="productName" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="包装规格" prop="spec" show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="批次号" prop="batchNo"></el-table-column>
        <el-table-column label="生产日期" prop="productDate"></el-table-column>
        <el-table-column label="失效日期" prop="expireDate"></el-table-column>
        <el-table-column label="单据数量" prop="count"></el-table-column>
      </el-table>
    </el-card>


    <el-dialog
      v-if="storageVisible"
      title="请选择单据所属仓库信息"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      append-to-body
      :visible.sync="storageVisible">

      <selectInvDialog
        :closeInvDialog="closeInvDialog"
        :billData="currentRow"
        :closeSubmitDialog="closeSubmitDialog"
      ></selectInvDialog>

    </el-dialog>
  </div>
</template>

<script>
import {addStockOrder, addThrOrder, getCloudErp} from "@/api/inout/erpOrder";
import store from "@/store";
import {getOriginBusType} from "@/api/basic/busOriginType";
import {filterAllByUser} from "@/api/system/invWarehouse";
import selectInvDialog from "./DialogSelectInv";
import {getBasicThirdSys} from "@/api/basic/basicThirdSys";
import {getThrOrderDetails, getThrOrders} from "@/api/thrsys/thrOrder";

export default {
  name: "closeDialog",
  props: {
    data: {
      type: Object,
      required: true,
    },
    closeDialog: {
      type: Function,
      required: true,
    },
  },

  data() {
    return {
      listQuery: {
        billNo: "",
        thirdSysFk: "",
        billAction: null,
        originType: null,
        page: 1,
        limit: 10,
        allocateStatus: 0,
        type: 0,
        corpName:null,
        customerId: null,
      },
      showSearch: true,
      detailList: [],
      storageVisible: false,
      dataList: [],
      pageTotal: 1,
      total: 1,
      currentRow: null,
      curLocInv: null,
      loading: false,
      multipleUdiSelection: [],
      thirdSys: [],
      thirdSysFk: null,
      busTypes: [],
      originTypes: [],
      storageList: [],
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      determineLoading: false,
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.listQuery = {
        billNo: "",
        corpName: null,
        billAction: null,
        page: 1,
        limit: 10,
        allocateStatus: 0,
      };
      this.actDateRange = [];
      this.getList();
    },

    tableRowClassName({row}) {
      if (row.checked) return "warning-row";
      return "";
    },
    checkSelectable(row) {
      return !row.check;
    },
    handleCurrentChange(val) {
      this.unionQuery.page = val;
      this.getList();
    },
    handleChange(row) {
      this.currentRow = row;
      let query = {orderIdFk: row.billNo};
      getThrOrderDetails(query)
        .then((response) => {
          if (response.code == 20000) {
            this.detailList = response.data.list || [];
          } else {
            this.$message.error(response.message);
          }
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
        });
    },
    handleErpPageChange(val) {
      this.listQuery.page = val;
      this.getList();
    },
    keyup_submit(event) {
      this.getList();
      event.target.select();
    },
    getList() {
      this.loading = true;
      if (this.actDateRange !== null) {
        this.listQuery.startDate = this.actDateRange[0];
        this.listQuery.endDate = this.actDateRange[1];
      } else {
        this.listQuery.startDate = null;
        this.listQuery.endDate = null;
      }
      this.listQuery.customerId = store.getters.customerId;
      getThrOrders(this.listQuery)
        .then((response) => {
          console.log(response)
          this.loading = false;
          if (response.code === 20000) {
            this.dataList = response.data.list || [];
            this.pageTotal = response.data.total || 0;
          } else {
            this.$message.error(response.message);
            this.dataList = [];
            this.pageTotal = 0;
          }
        })
        .catch(() => {
          this.loading = false;
          this.dataList = [];
          this.pageTotal = 0;
        });
    },
    intentBack() {
      this.closeDialog();
    },
    combine() {
      if (this.$isBlank(this.currentRow.id)) {
        return;
      }
      let tQuery = {
        id: this.currentRow.id,
        locStorageCode: this.curLocInv,
        invWarehouseCode: this.currentRow.invWarehouseCode,
      }
      this.determineLoading = true
      addThrOrder(tQuery)
        .then((response) => {
          this.determineLoading = false
          if (response.code === 20000) {
            this.closeDialog();
          } else {
            this.$message.error(response.message);
          }
        })
        .catch(() => {
          this.determineLoading = false
        });
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    submitFind() {
      this.listQuery.page = 1;
      this.getList();
    },
    selectStorage(row) {
      this.curLocInv = row.code;
      let tQuery = {
        id: this.currentRow.id,
        locStorageCode: this.curLocInv,
      }
      addStockOrder(tQuery)
        .then((response) => {
          if (response.code === 20000) {
            this.storageVisible = false;
            this.closeDialog();
          } else {
            this.$message.error(response.message);
          }
        })
        .catch(() => {
        });
    },

    handleSelectionUdiChange(val) {
      console.log("----" + val);
      this.multipleUdiSelection = val;
    },
    getBusType() {
      let query = {
        enabled: true,
        thirdSys: this.listQuery.thirdSysFk,
      };
      getOriginBusType(query)
        .then((response) => {
          this.originTypes = response.data.list || [];
        })
        .catch(() => {
        });
    },
    getStorage(event) {
      this.storageList = [];
      filterAllByUser()
        .then((response) => {
          this.storageList = response.data || [];
          if (this.storageList.length == 1) {
            this.curLocInv = this.storageList[0].code;
          }
        })
        .catch(() => {
        });
    },


    closeInvDialog() {
      this.storageVisible = false;
    },

    thirdSysChange() {
      this.listQuery.billAction = "";
      this.getBusType();
    },

    closeSubmitDialog() {
      this.storageVisible = false;
      this.combine();
    },


    getBasicThirdSys() {
      let query = {
        enabled: true,
      };
      getBasicThirdSys(query)
        .then((response) => {
          this.thirdSys = response.data.list || [];
          this.listQuery.thirdSysFk = this.thirdSys[0].thirdId;
          this.getBusType();
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
        });
    },


  }
  ,
  created() {

    this.getBasicThirdSys();
    this.getStorage();
  }
  ,
  components: {
    selectInvDialog
  }

}
;
</script>

<style scoped>

div /deep/ .el-table .warning-row {
  background: #bebebe;
}

div /deep/ .el-table .success-row {
  background: #ffffff;
}
</style>
